using SharedKernel.Helpers;
using SharedKernel.Extensions;
using MediatR;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Mvc.Rendering;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace Admin.Pages.Forum.Trash.Post
{
    public class IndexModel(IMediator mediator) : PageModel
    {
        [BindProperty(SupportsGet = true)]
        public QueryParams Query { get; set; } = new();

        public sealed class QueryParams
        {
            public int? BoardID { get; set; }
            public int? Search { get; set; }
            public string? Keyword { get; set; }
            public string? StartAt { get; set; }
            public string? EndAt { get; set; }

            [Range(1, int.MaxValue)]
            [DisplayName("페이지 번호")]
            public int PageNum { get; set; } = 1;

            [Range(1, 100)]
            [DisplayName("페이지 목록 수")]
            public ushort PerPage { get; set; } = 20;
        }

        public int Total { get; set; } = 0;
        public List<SelectListItem> BoardList { get; set; } = [];

        public List<(
            int Num,
            int ID,
            int BoardID,
            string BoardName,
            string Subject,
            string? Name,
            string? SID,
            int Views,
            int Comments,
            string? DeletedAt,
            string CreatedAt
        )> List { get; set; } = [];

        public Pagination? Pagination { get; set; }

        public async Task OnGetAsync(CancellationToken ct)
        {
            if (!ModelState.IsValid)
            {
                return;
            }

            var boards = await mediator.Send(new SearchBoards.Query(null, null, 1, 500), ct);
            BoardList = [..boards.List.Select(c => new SelectListItem
            {
                Value = c.ID.ToString(),
                Text = $"[{c.BoardGroupName}] {c.Name}"
            })];

            var result = await mediator.Send(new SearchTrashPosts.Query(
                Query.BoardID,
                Query.Search,
                Query.Keyword,
                Query.StartAt,
                Query.EndAt,
                Query.PageNum,
                Query.PerPage
            ), ct);

            Total = result.Total;
            List = [..result.List.Select(c => (
                c.Num,
                c.ID,
                c.BoardID,
                c.BoardName,
                c.Subject,
                c.Name,
                c.SID,
                c.Views,
                c.Comments,
                c.DeletedAt.GetDateAt() ?? "-",
                c.CreatedAt.GetDateAt()
            ))];

            Pagination = new Pagination(result.Total, Query.PageNum, Query.PerPage);
        }

        public async Task<IActionResult> OnPostRestoreAsync(int[] ids, CancellationToken ct)
        {
            try
            {
                await mediator.Send(new RestoreTrashPost.Command(ids), ct);

                TempData["SuccessMessage"] = $"{ids.Length}건이 복원되었습니다.";
            }
            catch (Exception e)
            {
                TempData["ErrorMessages"] = e.Message;
            }

            return RedirectToPage("/Forum/Trash/Post/Index", Query);
        }

        public async Task<IActionResult> OnPostDeleteAsync(int[] ids, CancellationToken ct)
        {
            try
            {
                await mediator.Send(new PermanentDeleteTrashPost.Command(ids), ct);

                TempData["SuccessMessage"] = $"{ids.Length}건이 영구 삭제되었습니다.";
            }
            catch (Exception e)
            {
                TempData["ErrorMessages"] = e.Message;
            }

            return RedirectToPage("/Forum/Trash/Post/Index", Query);
        }
    }
}